"""MSPowerpoint doc to text file converter for Document Library"""
 
from os import popen, remove
from sgmllib import SGMLParser
from string import join
 
content_type = ('application/mspowerpoint', 'application/ms-powerpoint', 
                'application/vnd.ms-powerpoint')
 
content_description = """Microsoft Powerpoint [<a 
href="http://office.microsoft.com/downloads/2000/Ppview97.aspx" 
target="_blank">Download Powerpoint Viewer</a>]"""
 
#uses pptHTML http://www.xlhtml.org
# Requires write access to /tmp

class _StripTagParser(SGMLParser):
  '''SGML Parser removing any tags and translating HTML entities.'''
 
  from htmlentitydefs import entitydefs
 
  data= None
 
  def handle_data(self,data):
    if self.data is None: self.data=[]
    self.data.append(data)
 
  def __str__(self):
    if self.data is None: return ''
    return join(self.data,'')

 
def convert(documentFile):
    """Convert MS-Powerpoint data to raw text"""
 
    tmp_name = documentFile._writeToTempFile()
    text = popen('pptHtml %s 2> /dev/null' % (tmp_name)).read()
    remove(tmp_name)
 
    p = _StripTagParser()
 
    try:
        p.feed(text)
        p.close()
        return str(p)
    except:
        return ''
